unit Grep;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Clipbrd, Param, GrThread;

type
  TGrepForm = class(TForm)
    Panel1: TPanel;
    ListBox1: TListBox;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Button1: TButton;
    Panel2: TPanel;
    Label3: TLabel;
    Edit3: TEdit;
    CheckBox1: TCheckBox;
    Button3: TButton;
    Button2: TButton;
    Button4: TButton;
    Button5: TButton;
    CheckBox2: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListBox1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private 錾 }
    Grt: TGrepThread;
    procedure TerminateHandler(Sender: TObject);
  public
    { Public 錾 }
    S: String;
  end;

var
  GrepForm: TGrepForm;

implementation

uses Frame;

{$R *.DFM}

procedure TGrepForm.TerminateHandler(Sender: TObject);
begin
  if Assigned(Grt) then
    S := Grt.Files
  else
    S := '';
  ListBox1.Items.Text := S;
end;

procedure TGrepForm.FormShow(Sender: TObject);
begin
  Left := FrameForm.Parameter1['GLeft'];
  Top := FrameForm.Parameter1['GTop'];
  Font.Style := FrameForm.Parameter1.VFontStyles['WGFontStyle'];
  Edit1.Text := FrameForm.Parameter1.VStrings['GStr'];
  CheckBox2.Checked := FrameForm.Parameter1.VBools['WGStamp'];
  ClientWidth := 460;
  ClientHeight := 408;
  Button1.Enabled := True;
  Button2.Enabled := False;
  Button3.Enabled := True;
  Button4.Enabled := False;
  Button5.Enabled := True;
  Caption := 'GrepEEE܂ރt@CB';
  Panel2.Caption := '';
  ListBox1.Clear;
  Edit2.Text := FrameForm.WorkDir;
  Edit3.Text := '*.*';
end;

procedure TGrepForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  WindowState := wsNormal;
  FrameForm.Parameter1['GLeft'] := Left;
  FrameForm.Parameter1['GTop'] := Top;
  FrameForm.Parameter1.VFontStyles['WGFontStyle'] := Font.Style;
  FrameForm.Parameter1.VStrings['GStr'] := Edit1.Text;
  FrameForm.Parameter1.VBools['WGStamp'] := CheckBox2.Checked;
  FrameForm.ListView1.SetFocus;
end;

procedure TGrepForm.Button1Click(Sender: TObject);
var
  S: String;
begin
  S := SelectFolder(Handle, 'n߂fBNgIĉB', '', -1, -1);
  if S <> '' then
  Edit2.Text := S;
end;

procedure TGrepForm.Button3Click(Sender: TObject);
begin
  Caption := 'łEEEEEEEE΂炭҂B';
  Panel2.Caption := '';
  Button1.Enabled := False;
  Button2.Enabled := True;
  Button3.Enabled := False;
  Button4.Enabled := False;
  Button5.Enabled := False;

  ListBox1.Clear;

  Grt := TGrepThread.Create(Edit1.Text, Edit2.Text, Edit3.Text, CheckBox1.Checked, CheckBox2.Checked );
  Grt.OnTerminate := TerminateHandler;
  Grt.Resume;

  if Assigned(Grt) then
  begin
    Grt.WaitFor;
    Grt.Free;
  end;

  if ListBox1.Items.Count = 0 then
  begin
    Caption := 'GrepEEE܂ރt@CB';
    Panel2.Caption := 'Not found.';
    ListBox1.ShowHint := False;
  end
  else
  begin
    ListBox1.SetFocus;
    ListBox1.ItemIndex := 0;
    Caption := 'GrepEEE܂ރt@CB';
    Panel2.Caption := IntToStr(ListBox1.Items.Count) + ' found.';
    ListBox1.ShowHint := True;
  end;

  Caption := 'GrepEEE܂ރt@CB';
  Button1.Enabled := True;
  Button2.Enabled := False;
  Button3.Enabled := True;
  if ListBox1.Items.Count > 0 then
    Button4.Enabled := True;
  Button5.Enabled := True;
end;

procedure TGrepForm.Button2Click(Sender: TObject);
begin
  if Assigned(Grt) then
    Grt.Terminate;
  Button1.Enabled := True;
  Button2.Enabled := False;
  Button3.Enabled := True;
  if ListBox1.Items.Count > 0 then
    Button4.Enabled := True;
  Button5.Enabled := True;
end;

procedure TGrepForm.ListBox1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i, j: Integer;
  Path, S: String;
  ListItem: TListItem;
begin
  if Key = 13 then
  begin
    i := ListBox1.ItemIndex;
    Path := ListBox1.Items[i];
    if Pos('/', Path) <> 0 then
      Path := Copy(Path, 1, Length(Path) - 23);
    S := ExtractFileName(Path); // t@C̕𓾂B
    Path := ExtractFilePath(Path) + FrameForm.WildCard;
    FrameForm.DispData(Path);
    ListItem := FrameForm.ListView1.ItemFocused;
    if Assigned(ListItem) then
    begin
      i := ListItem.Index;
      FrameForm.ListView1.Items.Item[i].Selected := False;
    end;

    j := FrameForm.SRecs.IndexOf(S);
    if j = -1 then j := 0;
    ListItem := FrameForm.ListView1.Items.Item[j];
    FrameForm.ListView1.Selected := ListItem;
    FrameForm.ListView1.ItemFocused := ListItem;
  end;
end;

procedure TGrepForm.Button4Click(Sender: TObject);
begin
  Clipboard.AsText := ListBox1.Items.Text;
end;

procedure TGrepForm.Button5Click(Sender: TObject);
begin
  if Font.Style = [] then
    Font.Style := [fsBold] // 
  else
    Font.Style := []; // W
end;

end.
