unit WhThread;

interface

uses
  Windows, SysUtils, Classes, Dialogs, Forms, ToolBox;

type
  TWhereisThread = class(TThread)
  private
    { Private 錾 }
    FFiles: String; // Tʂ̃t@CfBNgsŋ؂ēB
    FFileName: String; // Tt@C邢̓fBNg
    FDir: String; // TJnfBNg
    FOption: Integer; // T@(1: t@Ĉ, 2: fBNĝ, 3: t@CƃfBNg)
    FStamp: Boolean; // TʂɃ^CX^v邩߂B
    FCurFile: String; // t@C
    FCount: Integer; // Check Counter
    FFCount: Integer; // Found Counter
    procedure DispPanel;
    function Whereis(FileName: String; Dir: String; Option: Integer): String; // ċAT֐
  protected
    { protected 錾 }
    procedure Execute; override;
  public
    { public 錾 }
    constructor Create(FileName: String; Dir: String; Option: Integer; Stamp: Boolean);
    destructor Destroy; override;
    property Files: String read FFiles;
  end;

implementation

uses Whereis;

{ TWhereisThread }

constructor TWhereisThread.Create(FileName: String; Dir: String; Option: Integer; Stamp: Boolean);
begin
  inherited Create(True); // Suspended ԂŋN
  FFiles := '';
  FFileName := FileName;
  FDir := Dir;
  FOption := Option;
  FStamp := Stamp;
  FCurFile := '';
  FCount := 0;
  FFCount := 0;
end;

destructor TWhereisThread.Destroy;
begin
  FFiles := '';
  inherited Destroy;
end;

procedure TWhereisThread.Execute;
begin
  FFiles := Whereis(FFileName, FDir, FOption);
  FCurFile := '';
  Synchronize(DispPanel);
end;

procedure TWhereisThread.DispPanel;
var
  i, n: Integer;
  S: String;
begin
  WhereisForm.Panel2.Caption := '';
  WhereisForm.Panel2.UpDate;

  if FCurFile = '' then Exit;
  S := FCurFile;
  n := 0;
  i := Length(S);

  while i > 4 do
  begin
    if S[i] = '\' then Inc(n);
    if n = 2 then Break;
    Dec(i);
  end;

  if i > 4 then
    S := IntToStr(FFCount) + '   ...' + Copy(S, i, Length(S) - i + 1);

  WhereisForm.Panel2.Caption := S;
  WhereisForm.Panel2.UpDate;
end;

{ t@C邢̓fBNg FileName  Dir Ƃ̃TufBNg }
{ ֐łBFileName ɂ̓ChJ[h܂܂鎖o܂B}
{ ChJ[hƂ́At@ČɎgpʂȋL̎ŁA}
{ '*'  '?' ܂B'*' ͔Cӂ̒̕ŁA'?' ͔Cӂ 1  }
{ \킵܂BႦ΁A'*.*' ͑SẴt@C '*.txt' ͊gq'txt'  }
{ SẴt@C '*.c??' ͊gq 'c' Ŏn܂SẴt@C\킵܂B}
{ Option ́A1 ` 3 ̒lŁA̗lȓw肵܂B}
{ 1: t@Ĉ݂B}
{ 2: fBNĝ݂B}
{ 3: t@CƃfBNgB}
{ ߂ĺAYt@CfBNgsƂɕ\łB}

function TWhereisThread.Whereis(FileName: String; Dir: String; Option: Integer): String;
var
  i: Integer;
  R: TSearchRec;
  DTime: TDateTime;
  Path, S: String;
begin
  Result := '';

  if Terminated then Exit;

  {
  for i := 1 to Length(FileName) do
    if FileName[i] in ['\', '/', ':', '"', '<', '>', '|'] then Exit;
  if not DirectoryExists(Dir) then Exit;
  if not (Option in [1..3]) then Exit;
  }

  Path := Dir;
  if Path[Length(Path)] <> '\' then
    Path := Path + '\';

  i := FindFirst(Path + FileName, faAnyFile, R);
  try
    while i = 0 do
    begin
      if (R.Name <> '.') and (R.Name <> '..') then
      begin
        FCurFile := Path + R.Name;
        if ((Option = 1) and (R.Attr and faDirectory = 0)) or
           ((Option = 2) and (R.Attr and faDirectory > 0)) or
           (Option = 3) then
        begin
          Inc(FFCount); // 
          if FStamp and FileTimeToDateTime(R.FindData.ftLastWriteTime, DTime) then
            S := '    ' + FormatDateTime('yyyy/mm/dd hh:nn:ss', DTime)
          else
            S := '';
          Result := Result + FCurFile + S + #13#10;; // B
        end;
        Inc(FCount); // ׂ
        if FCount mod 20 = 1 then
          Synchronize(DispPanel);
      end;

      Synchronize(Application.ProcessMessages);
      if Terminated then Exit;

      i := FindNext(R);
    end;
  finally
    FindClose(R);
  end;

  Synchronize(Application.ProcessMessages);
  if Terminated then Exit;

  i := FindFirst(Path + '*.*', faAnyFile, R); // xׂ͂ẴfBNgB
  try
    while i = 0 do
    begin
      if (R.Attr and faDirectory > 0) and (R.Name <> '.') and (R.Name <> '..') then
        Result := Result + Whereis(FileName, Path + R.Name, Option);
      i := FindNext(R);
    end;
  finally
    FindClose(R);
  end;
end;

end.
