unit Whereis;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, FileCtrl, ComCtrls, Clipbrd, Param, WhThread;

type
  TWhereisForm = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    Button3: TButton;
    ListBox1: TListBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Button1: TButton;
    Button2: TButton;
    Panel2: TPanel;
    Button4: TButton;
    Button5: TButton;
    CheckBox1: TCheckBox;
    procedure Button3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ListBox1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private 錾 }
    Wht: TWhereisThread;
    procedure TerminateHandler(Sender: TObject);
  public
    { Public 錾 }
    S: String;
  end;

var
  WhereisForm: TWhereisForm;

implementation

uses Frame;

{$R *.DFM}

procedure TWhereisForm.TerminateHandler(Sender: TObject);
begin
  if Assigned(Wht) then
    S := Wht.Files
  else
    S := '';
  ListBox1.Items.Text := S;
end;

procedure TWhereisForm.Button3Click(Sender: TObject);
var
  i: Integer;
begin
  Caption := 'łEEEEEEEE΂炭҂B';
  Panel2.Caption := '';
  Button1.Enabled := False;
  Button2.Enabled := True;
  Button3.Enabled := False;
  Button4.Enabled := False;
  Button5.Enabled := False;

  if RadioButton1.Checked then i := 1
  else if RadioButton2.Checked then i := 2
  else i := 3;
  ListBox1.Clear;

  Wht := TWhereisThread.Create(Edit1.Text, Edit2.Text, i, CheckBox1.Checked);
  Wht.OnTerminate := TerminateHandler;
  Wht.Resume;

  if Assigned(Wht) then
  begin
    Wht.WaitFor;
    Wht.Free;
  end;

  if ListBox1.Items.Count = 0 then
  begin
    Caption := 'WhereisEEEt@CfBNgB';
    Panel2.Caption := 'Not found.';
    ListBox1.ShowHint := False;
  end
  else
  begin
    ListBox1.SetFocus;
    ListBox1.ItemIndex := 0;
    Caption := 'WhereisEEEt@CfBNgB';
    Panel2.Caption := IntToStr(ListBox1.Items.Count) + ' found.';
    ListBox1.ShowHint := True;
  end;

  Caption := 'WhereisEEEt@CfBNgB';
  Button1.Enabled := True;
  Button2.Enabled := False;
  Button3.Enabled := True;
  if ListBox1.Items.Count > 0 then
    Button4.Enabled := True;
  Button5.Enabled := True;
end;

procedure TWhereisForm.FormShow(Sender: TObject);
begin
  Left := FrameForm.Parameter1['WLeft'];
  Top := FrameForm.Parameter1['WTop'];
  Font.Style := FrameForm.Parameter1.VFontStyles['WGFontStyle'];
  Edit1.Text := FrameForm.Parameter1.VStrings['WStr'];
  CheckBox1.Checked := FrameForm.Parameter1.VBools['WGStamp'];
  ClientWidth := 460;
  ClientHeight := 414;
  Button1.Enabled := True;
  Button2.Enabled := False;
  Button3.Enabled := True;
  Button4.Enabled := False;
  Button5.Enabled := True;
  Caption := 'WhereisEEEt@CfBNgB';
  Panel2.Caption := '';
  ListBox1.Clear;
  Edit2.Text := FrameForm.WorkDir;
end;

procedure TWhereisForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  WindowState := wsNormal;
  FrameForm.Parameter1['WLeft'] := Left;
  FrameForm.Parameter1['WTop'] := Top;
  FrameForm.Parameter1.VFontStyles['WGFontStyle'] := Font.Style;
  FrameForm.Parameter1.VStrings['WStr'] := Edit1.Text;
  FrameForm.Parameter1.VBools['WGStamp'] := CheckBox1.Checked;
  FrameForm.ListView1.SetFocus;
end;

procedure TWhereisForm.ListBox1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i, j: Integer;
  Path, S: String;
  ListItem: TListItem;
begin
  if Key = 13 then
  begin
    i := ListBox1.ItemIndex;
    Path := ListBox1.Items[i];
    if Pos('/', Path) <> 0 then
      Path := Copy(Path, 1, Length(Path) - 23);
    S := ExtractFileName(Path); // t@C̕𓾂B
    Path := ExtractFilePath(Path) + FrameForm.WildCard;
    FrameForm.DispData(Path);
    ListItem := FrameForm.ListView1.ItemFocused;
    if Assigned(ListItem) then
    begin
      i := ListItem.Index;
      FrameForm.ListView1.Items.Item[i].Selected := False;
    end;

    j := FrameForm.SRecs.IndexOf(S);
    if j = -1 then j := 0;
    ListItem := FrameForm.ListView1.Items.Item[j];
    FrameForm.ListView1.Selected := ListItem;
    FrameForm.ListView1.ItemFocused := ListItem;
  end;
end;

procedure TWhereisForm.Button1Click(Sender: TObject);
var
  S: String;
begin
  S := SelectFolder(Handle, 'n߂fBNgIĉB', '', -1, -1);
  if S <> '' then
  Edit2.Text := S;
end;

procedure TWhereisForm.Button2Click(Sender: TObject);
begin
  if Assigned(Wht) then
    Wht.Terminate;
  Button1.Enabled := True;
  Button2.Enabled := False;
  Button3.Enabled := True;
  if ListBox1.Items.Count > 0 then
    Button4.Enabled := True;
  Button5.Enabled := True;
end;

procedure TWhereisForm.Button4Click(Sender: TObject);
begin
  Clipboard.AsText := ListBox1.Items.Text;
end;

procedure TWhereisForm.Button5Click(Sender: TObject);
begin
  if Font.Style = [] then
    Font.Style := [fsBold] // 
  else
    Font.Style := []; // W
end;

end.
